
' Pythagoras tree

#include "cairo/cairo.bi"
'#libpath "C:\GTK3\lib"

const PI = 4 * ATN(1)
const SURFACE_WIDTH = 600
const SURFACE_HEIGHT = 2 * SURFACE_WIDTH \ 3
const SQUARE_SIZE = SURFACE_HEIGHT \ 4

declare sub draw_branches( _
  byval c as cairo_t ptr, _
  byref x1 as const double, _
  byref y1 as const double, _
  byref s1 as const double, _
  byref n as const integer _
)

sub draw_branch( _
  byval c as cairo_t ptr, _
  byref x2 as const double, _
  byref y2 as const double, _
  byref a as const double, _
  byref x3 as const double, _
  byref y3 as const double, _
  byref s2 as const double, _
  byref n as const integer _
)
  cairo_save(c)
  cairo_translate(c, x2, y2)
  cairo_rotate(c, a)
  
  cairo_rectangle(c, x3, y3, s2, s2)
  cairo_set_source_rgba(c, 0, 0, 1, 0.6)
  cairo_fill_preserve(c)
  cairo_set_source_rgb(c, 0, 0, 1)
  cairo_stroke(c)
  
  draw_branches(c, x3, y3, s2, n - 1)
  cairo_restore(c)
end sub

sub draw_branches( _
  byval c as cairo_t ptr, _
  byref x1 as const double, _
  byref y1 as const double, _
  byref s1 as const double, _
  byref n as const integer _
)
  dim s2 as double
  if n > 0 then
    s2 = s1 / SQR(2)
    draw_branch(c, x1,      y1, -PI / 4,   0, -s2, s2, n)
    draw_branch(c, x1 + s1, y1,  PI / 4, -s2, -s2, s2, n)
  end if
end sub

ScreenRes SURFACE_WIDTH, SURFACE_HEIGHT, 32
WindowTitle "Pythagoras Tree"
Color 0, &hFFFFFF
Cls

' http://www.freebasic.net/forum/viewtopic.php?p=215063#p215063
#define BYTES_PER_PIXEL 4

var surface = cairo_image_surface_create_for_data( _
  ScreenPtr(), _
  CAIRO_FORMAT_ARGB32, _
  SURFACE_WIDTH, _
  SURFACE_HEIGHT, _
  SURFACE_WIDTH * BYTES_PER_PIXEL _
)

var context = cairo_create(surface)

const as double X = (SURFACE_WIDTH - SQUARE_SIZE) / 2
const as double Y = SURFACE_HEIGHT - SQUARE_SIZE

ScreenLock()

cairo_rectangle(context, X, Y, SQUARE_SIZE, SQUARE_SIZE)
cairo_set_source_rgba(context, 0, 0, 1, 0.6)
cairo_fill_preserve(context)
cairo_set_line_width(context, 2)
cairo_set_source_rgb(context, 0, 0, 1)
cairo_stroke(context)

draw_branches(context, x, y, SQUARE_SIZE, 4)

ScreenUnlock()

cairo_destroy(context)
cairo_surface_destroy(surface)

Sleep
